#ifndef MYNETWORK_H
#define MYNETWORK_H

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>
#include <string>
#include <cstring>

//some Definitions
#define BACKLOG 10 //number of clients that can connect at once while in server mode.

class MyNetwork
{
    public:

    MyNetwork(char *_port);
     ~MyNetwork();

    static const int MAXDATA =128;
    typedef void (*ptrFunc)(int);
    bool isData();
	void sendPacket(std::string* buff, int msgSize);
	void sendPacket(const char* msg);
	
	char* readPacket();
	bool charSearch(const char *buffer, const char *searchString);
	int start(ptrFunc myFunc);

    


    protected:



    private:

	//setup structs
	struct addrinfo hints, *result, *p;
	struct sockaddr_storage theirAddr;
	socklen_t addrSize;
	struct sigaction sa;

	char inAddr[INET_ADDRSTRLEN];
	char * addr;
	char * port;
	int type;
	int s; //socket descriptor
	bool running;
	int newSock; // fork socket when used as server
	static const int buffLimit = 1024; //buffer limit for reading packets
	
	
	char buff[buffLimit];
	

	////////class methods////////////
	
	void clearBuff(); //clears the inBuffer

	int acceptLoop(ptrFunc myFunc); // loop used to accept and process new connections

	static void sigHandle(int s); // reaps all dead processes.

	static void *get_in_addr(struct sockaddr *sa);

};

#endif // MYNETWORK_H
